
#include   "EEPROM.H"

//========================================================================
// : void	ISP_Disable(void)
// : ֹISP/IAP.
// : non.
// : non.
// 汾: V1.0, 2012-10-22
//========================================================================
void	DisableEEPROM(void)
{
	IAP_CONTR = 0;			//ֹIAP
	IAP_CMD   = 0;			//ȥIAP
	IAP_TRIG  = 0;			//ֹIAP󴥷
	IAP_ADDRH = 0xff;		//0ַֽ
	IAP_ADDRL = 0xff;		//0ַֽڣָEEPROMֹ
}

//========================================================================
// : void EEPROM_Trig(void)
// : EEPROM.
// : none.
// : none.
// 汾: V1.0, 2014-6-30
//========================================================================
void EEPROM_Trig(void)
{
	F0 = EA;    //ȫж
	EA = 0;     //ֹж, ⴥЧ
	IAP_TRIG = 0x5A;
	IAP_TRIG = 0xA5;                    //5AHA5HIAPĴÿζҪ
																			//A5HIAP
																			//CPUȴIAPɺ󣬲Żִг
	_nop_();
	_nop_();
	EA = F0;    //ָȫж
}

//========================================================================
// : void EEPROM_read_n(u16 EE_address,u8 *DataAddress,u16 number)
// : ָEEPROM׵ַnֽڷָĻ.
// : EE_address:  EEPROM׵ַ.
//       DataAddress: ݷŻ׵ַ.
//       number:      ֽڳ.
// : non.
// 汾: V1.0, 2012-10-22
//========================================================================
void EEPROM_read_n(u16 EE_address,u8 *DataAddress,u16 number)
{
	IAP_ENABLE();                           //õȴʱ䣬IAPһξ͹
	IAP_READ();                             //ֽڶıʱ
	do
	{
		IAP_ADDRH = EE_address / 256;       //͵ַֽڣַҪıʱ͵ַ
		IAP_ADDRL = EE_address % 256;       //͵ַֽ
		EEPROM_Trig();                      //EEPROM
		*DataAddress = IAP_DATA;            //
		EE_address++;
		DataAddress++;
	}while(--number);

	DisableEEPROM();
}

//========================================================================
// : void EEPROM_SectorErase(u16 EE_address)
// : ַָEEPROM.
// : EE_address:  ҪEEPROMĵַ.
// : non.
// 汾: V1.0, 2013-5-10
//========================================================================
void EEPROM_SectorErase(u16 EE_address)
{
	IAP_ENABLE();                       //õȴʱ䣬IAPһξ͹
	IAP_ERASE();                        //, ıʱ
																			//ֻûֽڲ512ֽ/
																			//һֽڵַַ
	IAP_ADDRH = EE_address / 256;       //ַֽڣַҪıʱ͵ַ
	IAP_ADDRL = EE_address % 256;       //ַֽ
	EEPROM_Trig();                      //EEPROM
	DisableEEPROM();                    //ֹEEPROM
}

//========================================================================
// : void EEPROM_write_n(u16 EE_address,u8 *DataAddress,u16 number)
// : ѻnֽдָ׵ַEEPROM.
// : EE_address:  дEEPROM׵ַ.
//       DataAddress: дԴݵĻ׵ַ.
//       number:      дֽڳ.
// : non.
// 汾: V1.0, 2012-10-22
//========================================================================
void EEPROM_write_n(u16 EE_address,u8 *DataAddress,u16 number)
{	
	
	 EEPROM_SectorErase(EE_address);
	
	IAP_ENABLE();                       //õȴʱ䣬IAPһξ͹
	IAP_WRITE();                        //, ֽд
	do
	{
		IAP_ADDRH = EE_address / 256;     //͵ַֽڣַҪıʱ͵ַ
		IAP_ADDRL = EE_address % 256;     //͵ַֽ
		IAP_DATA  = *DataAddress;         //ݵIAP_DATAֻݸıʱ
		EEPROM_Trig();                    //EEPROM
		EE_address++;                     //һַ
		DataAddress++;                    //һ
	}while(--number);                   //ֱ
	DisableEEPROM();
}



/************************************************************************/
/* : void EEPROM_init(void)											*/
/* : EEPROMʼ													*/
/* : None.															*/
/* : None.															*/
/* 汾: V1.0  2023-07-11												*/
/************************************************************************/
#ifdef ENABLE_EEPROM

void EEPROM_init(void)
{
	EEPROM_read_n(Set_address, (unsigned char *)(&Set), sizeof(Set));

	if( Set.key != 0x1235 ) 					
	{
		Work.key = Set.key = 0x1235;								//
		Work.Time = Set.Time =  Rset_time; 							//ʱ				
		Work.Temp = Set.Temp = Rset_temp;							//Ĭ¶
		Work.Intensity = Set.Intensity = Rset_Intensity;			//Ĭǿ
		Work.mode = Set.mode = Rset_mode;							//Ĭģʽ
		Work.ON_OFF = OFF;
		EEPROM_SectorErase(Set_address);
		EEPROM_write_n(Set_address, (unsigned char *)(&Set), sizeof(Set));				
	}
	else
	{
		Work.key = Set.key ;					//
		Work.Time = Set.Time; 					//ʱ				
		Work.Temp = Set.Temp;					//Ĭ¶
		Work.Intensity = Set.Intensity;			//Ĭǿ
		Work.mode = Set.mode;					//Ĭģʽ
		Work.ON_OFF = Set.ON_OFF = 0;		
	}	
}

/************************************************************************/
/* : void EEPROM_save(void)											*/
/* : EEPROMݴ洢													*/
/* : None.															*/
/* : None.															*/
/* 汾: V1.0  2024-01-02												*/
/************************************************************************/
void EEPROM_save(void)
{
	if( EE_flag == 1)
	{
		Set.key = 0x1235;
		EEPROM_SectorErase(Set_address) ;
		EEPROM_write_n(Set_address, (unsigned char *)(&Set), sizeof(Set));
		EE_flag = 0;
	}
}

#endif


/**********************   END  *******************************************/