/*---------------------------------------------------------------------*/
/* --------------------------------------------------------------------*/
/* --------------------------------------------------------------------*/
/* --------------------------------------------------------------------*/
/* ---    дС            ---------------------------------------*/
/*---------------------------------------------------------------------*/


#include   "System_init.h"


#define   Time0_10ms     ( 65536-(MAIN_Fosc/12/1000*10) )			//T0 1msʱʼֵ
#define   Time3_1ms      ( 65536-(MAIN_Fosc/12/1000) )				//T3 1msʱʼֵ

#define   Uart1_baud     ( 65536 - (MAIN_Fosc/4/19200) )			//Uart1 
#define   Uart2_baud     ( 65536 - (MAIN_Fosc/4/19200) )			//Uart1 


/************************************************************************/
/* : void delay_ms(unsigned int ms)									*/
/* : ʱ														*/
/* : ʱ24MHZ														*/
/* : None.															*/
/* 汾: V1.0  2023-10-02												*/
/************************************************************************/
void delay_ms(unsigned int ms)
{
	unsigned int i;
	do{
		i = MAIN_Fosc / 10000;
		while(--i);
	}while(--ms);
}


/************************************************************************/
/* : void	GPIO_config(void)										*/
/* : IO											     		*/
/* : None.															*/
/* : None.															*/
/* 汾: V1.0  2024-01-02												*/
/************************************************************************/
void	GPIO_config(void)
{
	P3_MODE_OUT_PP(GPIO_Pin_7);		
	P3_MODE_IO_PU(GPIO_Pin_6);

	P1_MODE_OUT_PP(GPIO_Pin_1);
	P1_MODE_IO_PU(GPIO_Pin_0);
	
	P3_MODE_OUT_PP(GPIO_Pin_1);
	P3_MODE_IO_PU(GPIO_Pin_0);

	P3_MODE_OUT_PP(GPIO_Pin_2|GPIO_Pin_4|GPIO_Pin_3|GPIO_Pin_5);		
	
	P1_MODE_IO_PU(GPIO_Pin_7|GPIO_Pin_6);
	P5_MODE_IO_PU(GPIO_Pin_4);
	
	P1_PULL_UP_ENABLE(GPIO_Pin_7|GPIO_Pin_6)
	P5_PULL_UP_ENABLE(GPIO_Pin_4)
	
	W_led_OFF();
		
}




/************************************************************************/
/* : void	UART1_config(void)										*/
/* : 1											     		*/
/* : None.															*/
/* : None.															*/
/* 汾: V1.0  2024-01-02												*/
/************************************************************************/
void UART1_config(void)	
{
	SCON = 0x50;				//8λ,ɱ䲨
	AUXR = 0x00;				//1ѡʱ1Ϊʷ
	AUXR |= 0x40;				//ʱʱ1Tģʽ	
//	TMOD &= 0x0F;				//öʱģʽ	
	TH1 = Uart1_baud >> 8;		//öʱʼֵ
	TL1 = Uart1_baud;			//öʱʼֵ
	ET1 = 0;					//ֹʱ%dж
	TR1 = 1;					//ʱ1ʼʱ
	ES  = 1;					//ж
	
	P_SW1 |= 0X40;				//1лP3.6 3.7
}

/************************************************************************/
/* : void	UART1_config(void)										*/
/* : 1											     		*/
/* : None.															*/
/* : None.															*/
/* 汾: V1.0  2024-01-02												*/
/************************************************************************/
void UART2_config(void)	
{
	S2CON = 0x50;				//8λ,ɱ䲨
	AUXR |= 0x04;				//ʱʱ1Tģʽ
	T2H =  Uart2_baud >> 8;		//öʱʼֵ
	T2L = Uart2_baud ;			//öʱʼֵ
	AUXR |= 0x10;				//ʱ2ʼʱ
	IE2 |= 0x01;                 //ʹܴ2ж
}


/************************************************************************/
/* : void	Timer_config(void)										*/
/* : 1											     		*/
/* : None.															*/
/* : None.															*/
/* 汾: V1.0  2024-01-02												*/
/************************************************************************/
void	Timer_config(void)
{
	AUXR &= 0x7F;				//ʱʱ12Tģʽ
	
//	TMOD &= 0xF0;				//öʱģʽ
	TH0 = Time0_10ms >> 8;		//öʱʼֵ
	TL0 = Time0_10ms;			//öʱʼֵ
	TF0 = 0;					//TF0־
	TR0 = 1;					//ʱ0ʼʱ
	ET0 = 1;
	
	
	T4T3M &= 0xFD;				//ʱʱ12Tģʽ
	T3H = Time3_1ms >> 8;		//öʱʼֵ
	T3L = Time3_1ms;			//öʱʼֵ
	T4T3M |= 0x08;				//ʱ3ʼʱ
	IE2 |= ET3;

}


/************************************************************************/
/* : void WDT_init(void)    										*/
/* : Źʼ 													*/
/* : Ƶ24MHZ Źλʱ1.048									*/
/* : None.															*/
/* 汾: V1.0  2024-01-02												*/
/************************************************************************/
void WDT_init(void)
{
	WDT_CONTR = 0x07;       //Źʱʱ㹫ʽ: (12 * 32768 * PS) / FOSC ()
                            //ÿŹʱƵΪ32,ʱ:                        
    WDT_CONTR |= 0x20;      //Ź
}


/************************************************************************/
/* : void RAM_Init(void)         									*/
/* : RAMʼ 													    */
/* : None.															*/
/* : None.															*/
/* 汾: V1.0  2024-01-02												*/
/************************************************************************/
void RAM_Init(void)
{
	memset(&Mode0, 0, sizeof(Mode0));
	memset(&Mode1, 0, sizeof(Mode1));
	memset(&Mode2, 0, sizeof(Mode2));
	memset(&Key12, 0, sizeof(Key12));
	memset(&Key3, 0, sizeof(Key3));
}

/************************************************************************/
/* : void	SYS_Init(void)											*/
/* : ϵͳʼ 														*/
/* : None.															*/
/* : None.															*/
/* 汾: V1.0  2024-01-02												*/
/************************************************************************/
void SYS_Init(void)
{
	delay_ms(200);				//ʱ
	RAM_Init();					//RAMݳʼ
	GPIO_config();				//˿	
	UART1_config();
	UART2_config();
	Timer_config();				//ʱ
	WS2812_Init();
	EA = 1;						//ʹȫж		
	WDT_init();					//ʹܿŹŹλʱԼ1.14		
}

/**********************   END  *******************************************/
